<%@ Control Language="c#" AutoEventWireup="True" CodeBehind="ViewArticle.ascx.cs"
    Inherits="DigNuke.DNN.Modules.DigArticle.ViewArticle" %>
<%@ Register Src="../../controls/LabelControl.ascx" TagName="Label" TagPrefix="dnn" %>
<%@ Register TagPrefix="dnn" TagName="TextEditor" Src="~/controls/TextEditor.ascx" %>
<%@ Register TagPrefix="dnn" Assembly="DotNetNuke" Namespace="DotNetNuke.UI.WebControls" %>
<%@ Register TagPrefix="dig" Assembly="DigNuke.DNN.Modules.DigArticle" Namespace="DigNuke.DNN.Utility" %>

<asp:UpdatePanel ID="UpdatePanel1" runat="server" OnUnload="UpdatePanel1_Unload">
    <ContentTemplate>
        <asp:PlaceHolder ID="ph" runat="server"></asp:PlaceHolder>
        <asp:Panel ID="digArticleCommentHolder" runat="server">
            <div id="digArticleComment">
                <div id="commentInfoHolder"></div>
                <asp:TextBox ID="ctlCommentText" CssClass="join" runat="server" Rows="2" TextMode="MultiLine" Width="90%" Text="Join the Discussion..."></asp:TextBox>
            </div>
        </asp:Panel>
        <div id="digArticleReplyHolder" runat="server">
            <asp:Panel runat="server" ID="commentHolder">
            </asp:Panel>
            <div id="digArticleReplyHolder2"></div>
            <div id="digArticleReply" style="display: none">
                <div>
                    <asp:TextBox ID="ctlReplyText" runat="server" Width="95%" Rows="7" TextMode="MultiLine"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="valReplyRequired" runat="server" ControlToValidate="ctlReplyText"
                        CssClass="red" Display="Dynamic" ErrorMessage="* Required" ValidationGroup="reply"
                        resourcekey="valRequired"></asp:RequiredFieldValidator>
                    <br />
                    <% if( EnableCommentImage ) { %>
                    <asp:ImageButton CssClass="commentMediabutton" runat="server" ID="cmdCommentSelectImage" ToolTip="Select Image" OnClientClick="SelectImage();return false;" ImageUrl="~/DesktopModules/DigArticle/images/comment-photo.png"></asp:ImageButton>
                    <a href="#" class="commentMediaButton" ID="cmdCommentUploadImg"><asp:Image runat="server" style="border:none" ImageUrl="~/DesktopModules/DigArticle/images/comment-photoup.png" /></a>
                    <% } %>
                    <% if( EnableCommentVideo ) { %>
                    <asp:ImageButton CssClass="commentMediabutton" runat="server" ID="cmdCommentSelectVideo" ToolTip="Select Video" OnClientClick="SelectVideo();return false;" ImageUrl="~/DesktopModules/DigArticle/images/comment-video.png"></asp:ImageButton>
                    <% } %>
                    <% if( EnableCommentVideo && EnableCommentVideoUpload) { %>
                    <asp:HyperLink CssClass="commentMediabutton" runat="server" ID="lnkUploadVideo" ToolTip="Upload Video"  ImageUrl="~/DesktopModules/DigArticle/images/comment-videoup.png"></asp:HyperLink>
                    <% } %>
                    <% if( EnableCommentEmbed ) { %>
                    <asp:Label runat="server" ID="lblCommentEmbed" ResourceKey="CommentEmbed"></asp:Label>
                    <%} %>
                    <% if( EnableCommentVideo || EnableCommentImage) { %>
                    <asp:Panel ID="panelUload" runat="server" style="display:inline-block;width:100%"></asp:Panel>
                    <div id="cmSelectedItem" class="da_selected_comment">
                        <asp:HiddenField ID="hfSelectedImage" runat="server" />
                        <img id="comSelectedImage" style="max-width: 200px; max-height: 200px" />
                        <span id="comSelectedTitle"></span>
                        <a href="javascript:CancelImage()">Cancel</a>
                    </div>
                    <% } %>
                </div>
                <div>
                    <asp:TextBox ID="ctlReplyName" runat="server" Width="50%"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="valReplyName" runat="server" ControlToValidate="ctlReplyName"
                        CssClass="red" Display="Dynamic" ErrorMessage="Required" ValidationGroup="reply"
                        resourcekey="valRequired"></asp:RequiredFieldValidator>
                </div>
                <div>
                    <asp:TextBox ID="ctlReplyEmail" runat="server" Width="50%"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="valReplyEmail" runat="server" ControlToValidate="ctlReplyEmail"
                        CssClass="red" Display="Dynamic" ErrorMessage="Required" ValidationGroup="reply"
                        resourcekey="valRequired"></asp:RequiredFieldValidator>
                    <asp:RegularExpressionValidator resourcekey="valInvalidEmail" ID="valReplyEmailFormat" runat="server" ErrorMessage="RegularExpressionValidator" ValidationExpression="\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*" ControlToValidate="ctlReplyEmail" Display="Dynamic" ValidationGroup="reply"></asp:RegularExpressionValidator>
                </div>
                <div>
                    <asp:TextBox ID="ctlReplyWebsite" runat="server" Width="50%"></asp:TextBox>
                </div>
                <div>
                    <dnn:CaptchaControl ID="ctlReplyCaptcha" CaptchaHeight="40" CaptchaWidth="150" ErrorStyle-CssClass="NormalRed"
                        CssClass="Normal" runat="server" ErrorMessage="The typed code must match the image, please try again" />
                    <dig:DigReCaptcha runat="server" ID="recap" ResourceKey="valCaptcha"></dig:DigReCaptcha>
                </div>
                <div>
                    <asp:CheckBox ID="ctlReplyNotify" runat="server" CssClass="normal" resourcekey="ctlNotify"
                        Text="Notify me of followup comments via e-mail" />
                    <br />
                    <asp:Panel runat="server" ID="panelCommentTerms">
                    <asp:CheckBox ID="ctlCommentTerms" runat="server" CssClass="comment-terms" Text="" />
                    <asp:Label ID="ctlCommentTermsExtra" runat="server" CssClass="normal"
                        Text="" />
                    <asp:CustomValidator ID="valCommentTerms" runat="server"  EnableClientScript="true" ClientValidationFunction="ctlCommentTerms_ClientValidate"
                        CssClass="red" Display="Dynamic" ErrorMessage="Required" ValidationGroup="reply" OnServerValidate="ctlCommentTerms_ServerValidate"
                        resourcekey="valRequired"></asp:CustomValidator>
                    <br />
                        </asp:Panel>
                    <asp:LinkButton ID="cmdPostReply" runat="server" OnClick="cmdPostReply_Click" resourcekey="cmdPost"
                        CssClass="dig_btn2" ValidationGroup="reply" OnClientClick="da_spin(this, 'reply');">Post Reply</asp:LinkButton>

                    <asp:HiddenField ID="digArticleReplyID" runat="server" />
                </div>
            </div>
        </div>
        <div id="digArticleAlertHolder" runat="server">
            <div id="digArticleAlertHolder2"></div>
            <div id="digArticleAlert" class="da_com_alert" style="display: none">
                <table>
                    <tr>
                        <td class="normal">&nbsp;</td>
                        <td class="normal">
                            <dnn:Label ID="lblAlertReason" runat="server" ResourceKey="lblAlertReason" />
                        </td>
                    </tr>
                    <tr>
                        <td class="normal">&nbsp;</td>
                        <td>
                            <asp:TextBox ID="ctlAlertReason" runat="server" Columns="50" Rows="7" TextMode="MultiLine"></asp:TextBox>
                            <asp:RequiredFieldValidator ID="valAlertReason" runat="server" ControlToValidate="ctlAlertReason"
                                CssClass="normalred" Display="Dynamic" ErrorMessage="* Required" ValidationGroup="alert"
                                resourcekey="valRequired"></asp:RequiredFieldValidator>
                        </td>
                    </tr>
                    <tr>
                        <td></td>
                        <td>&nbsp;</td>
                    </tr>
                    <tr>
                        <td>&nbsp;
                        </td>
                        <td>
                            <asp:LinkButton ID="cmdSendAlert" runat="server" OnClick="cmdSendAlert_Click" resourcekey="cmdSendAlert"
                                CssClass="dig_btn2" ValidationGroup="alert" OnClientClick="da_spin(this, 'alert');">Send Alert</asp:LinkButton>
                            <br />
                            <asp:HiddenField ID="digArticleAlertID" runat="server" />
                        </td>
                    </tr>
                </table>
            </div>
        </div>
    </ContentTemplate>
    <Triggers>
    </Triggers>
</asp:UpdatePanel>

                    <asp:PlaceHolder ID="phUploadControls" runat="server"></asp:PlaceHolder>
<% if (EnableCommentImage) { %>
<div id="media" title="<%=GetLocalString("SelectImageTitle.Text")%>" style="display: none;max-height:500px">
    <div id="mediaList" class="da_comment_selector">
    </div>
    <div id="mediaPreview" class="da_comment_preview">
        <img id="mediaPreviewImage" />
        <input type="hidden" id="mediaSelectedID" />
    </div>
</div>
<% } %>
<% if (EnableCommentVideo) { %>
<div id="mediaVideo" title="<%=GetLocalString("SelectVideoTitle.Text")%>" style="display: none">
    <div id="mediaListVideo" class="da_comment_selector">
    </div>
    <div id="mediaPreviewVid" class="da_comment_preview">

        <video id="mediaPreviewVideo" width="150" height="150" >
            <source type="video/mp4"  />
        </video>

        <input type="hidden" id="mediaSelectedVideoID" />
        <input type="hidden" id="mediaSelectedVideoTitle" />
    </div>
</div>
<% } %>
<script type="text/javascript">
    var player;
    jQuery(document).ready(function ($) {
<% if (EnableCommentVideo) { %>
        player = new MediaElementPlayer('#mediaPreviewVideo', {
                features: ['playpause', 'progress', 'current', 'duration', 'volume', 'fullscreen'],
                plugins: ['flash', 'silverlight'],
                success: function (mediaElement, originalNode) {
                    // do things
                }
            });
    <%}%>
            
    });

    <% if (EnableCommentVideo) { %>

    var videoData;
    var popup;
    function SelectVideo() {
        jQuery.getJSON("/DesktopModules/DigArticle/DataHandler.ashx?cmd=getuservideos")
        .done(function (data) {
            videoData = data;
            var ul = jQuery("<ul>").appendTo(("#mediaListVideo"));
            jQuery.each(data, function (i, item) {
                ul.append(jQuery("<li>").append(
                    jQuery("<a>").attr("href", "javascript:SelectVideoAt('" + item.id + "')").append(
                        jQuery("<span>" + item.name + "</span>"))));
                //                jQuery("<a href='javascript:SelectImageAt("+item.id+")'><img src='"+item.url+"' /></a>").appendTo('#mediaList');
            });
            popup = jQuery('#mediaVideo').dialog({
                height: 500, width:600, responsive:true, resizable:false, dialogClass: "dnnFormPopup", modal: true,
                buttons: {
                    "<%=GetLocalString("SelectVideo.Text")%>": function () {
                        jQuery("[id$=hfSelectedImage]").val(jQuery(popup).find("#mediaSelectedVideoID").val());
                        jQuery('#comSelectedTitle').html(jQuery(popup).find("#mediaSelectedVideoTitle").val());
                        jQuery("#cmSelectedItem").fadeIn("fast");
                        player.pause();
                        player.setSrc('');
                        $(this).dialog("close");
                    },
                    Cancel: function () {
                        player.pause();
                        player.setSrc('');
                        $(this).dialog("close");
                    }
                }

            });
        });
    }
    jQuery('#mediaVideo').scroll(function () {
        jQuery('#mediaPreviewVid').css('padding-top', (jQuery('#mediaVideo').scrollTop() ));
    });
    function SelectVideoAt(value) {
        jQuery.each(videoData, function (i, item) {
            if (item.id == value) {
                player.setSrc(item.url, 'video/mp4');
                jQuery('#mediaSelectedVideoTitle').val(item.name);
                jQuery(popup).find('#mediaSelectedVideoID').val(item.url);
                player.play();
                return;
            }
        });
        jQuery("[id$=hfSelectedImage]").val(value);
        // jQuery('#media').dialog("close");
    }

    <% } %>
    <% if( EnableCommentImage ) { %>
    var imageData;

    function SelectImage() {
        jQuery.getJSON("/DesktopModules/DigArticle/DataHandler.ashx?cmd=getuserimages")
        .done(function (data) {
            imageData = data;
            var ul = jQuery("<ul>").appendTo(("#mediaList"));
            jQuery.each(data, function (i, item) {
                ul.append(jQuery("<li>").append(
                    jQuery("<a>").attr("href", "javascript:SelectImageAt('" + item.id + "')").append(
                        jQuery("<span>" + item.name + "</span>"))));
                //                jQuery("<a href='javascript:SelectImageAt("+item.id+")'><img src='"+item.url+"' /></a>").appendTo('#mediaList');
            });
            popup = jQuery('#media').dialog({
                height: 500, width:600, responsive:true, response:true, resizable:false, dialogClass: "dnnFormPopup", modal: true,
                buttons: {
                    "<%=GetLocalString("SelectImage.Text")%>": function () {
                        jQuery("[id$=hfSelectedImage]").val(jQuery(popup).find("#mediaSelectedID").val());
                        jQuery('#comSelectedImage').attr("src", jQuery(popup).find("#mediaPreviewImage").attr("src"));
                        jQuery("#cmSelectedItem").fadeIn("fast");
                        $(this).dialog("close");
                    },
                    Cancel: function () {
                        $(this).dialog("close");
                    }
                }

            });
        });
    }

    jQuery('#media').scroll(function () {
        jQuery('#mediaPreview').css('padding-top',(jQuery('#media').scrollTop()));
    });

    function FileUploadComplete(uploader, file, response) {
        var resp = jQuery.parseJSON(response.response);
        jQuery('#comSelectedImage').attr("src", resp.url);
        jQuery("[id$=hfSelectedImage]").val(resp.id);
        jQuery("#cmSelectedItem").fadeIn("fast");
        return false;
    }

    function SelectImageAt(value) {
        jQuery.each(imageData, function (i, item) {
            if (item.id == value) {
                jQuery(popup).find('#mediaPreviewImage').attr("src", item.url);
                jQuery(popup).find('#mediaSelectedID').val(item.id);
                return;
            }
        });
        jQuery("[id$=hfSelectedImage]").val(value);
        // jQuery('#media').dialog("close");
    }
    <% } %>

    <% if( EnableCommentImage || EnableCommentVideo ) { %>
    function CancelImage() {
        jQuery("#cmSelectedItem").fadeOut("fast");
        jQuery("[id$=hfSelectedImage]").val("");
    }
    <% } %>

    jQuery(function () {
        CommentInit();
    });

    function MoveJoin() {
        var ph = jQuery('div[id$=PostHolder]');
        var ch = jQuery('div[id$=digArticleCommentHolder]');
        if (ph.length && ch.length)
            ch.appendTo(ph);

        var usr = jQuery('textarea[name$=ctlCommentText]');
        usr.click(function () {
            var ch = jQuery('textarea[name$=ctlCommentText]');
            var idh = jQuery('input[name$=digArticleReplyID]');
            var rt = jQuery('textarea[name$=ctlReplyText]');

            ch.hide();

            jQuery("#digArticleReply").appendTo("#commentInfoHolder").show("fast");
            idh.val(0);
            rt.val('');
            rt.focus();            
        });
    }

    function CommentInit() {
        MoveJoin();
        jQuery('input, textarea').placeholder();
        jQuery('video').mediaelementplayer();
        if( window.location.href.indexOf('cpage') != -1 )
        {
            jQuery('html,body').animate({
                scrollTop: jQuery("#digArticleComment").offset().top
            });
        }
    }

    function DigReplyMove(to, id, idholder) {
        var idh = jQuery('input[name$=digArticleReplyID]');
        var ch = jQuery('textarea[name$=ctlCommentText]');
        var rt = jQuery('textarea[name$=ctlReplyText]');
        var rp = jQuery("#digArticleReply");

        if (rp.parent().attr('id') == to.substring(1) && rp.is(":visible") ) {
            rp.hide("fast");
        }
        else {
            if (rp.parent().attr('id') != to.substring(1))
                rt.val('');
            jQuery("#digArticleAlert").appendTo("#digArticleAlertHolder2");
            rp.appendTo(to).show("fast");
            idh.val(id);
            ch.show();
            rt.focus();
        }
    }

    function DigAlertMove(to, id) {
        var idh = jQuery('input[name$=digArticleReplyID]');
        var ch = jQuery('textarea[name$=ctlAlertReason]');
        var alt = jQuery("#digArticleAlert");

        if (alt.parent().attr('id') == to.substring(1) && alt.is(":visible")) {
            alt.hide("fast");
        }
        else {
            jQuery("#digArticleReply").appendTo("#digArticleReplyHolder2");
            alt.appendTo(to).show("fast");
            idh.val(id);
            ch.focus();
        }
    }



    function ResetRecaptcha() {
        MoveJoin();
        CaptchaCallback();
        grecaptcha.reset();
    }

    <% if( EnableCommentImage || EnableCommentVideo ) { %>
    // add new options with default values
    $.ui.dialog.prototype.options.clickOut = true;
    $.ui.dialog.prototype.options.responsive = true;
    $.ui.dialog.prototype.options.scaleH = 0.8;
    $.ui.dialog.prototype.options.scaleW = 0.8;
    $.ui.dialog.prototype.options.showTitleBar = true;
    $.ui.dialog.prototype.options.showCloseButton = true;


    // extend _init
    var _init = $.ui.dialog.prototype._init;
    $.ui.dialog.prototype._init = function () {
        var self = this;

        // apply original arguments
        _init.apply(this, arguments);

        //patch
        if ($.ui && $.ui.dialog && $.ui.dialog.overlay) {
            $.ui.dialog.overlay.events = $.map('focus,keydown,keypress'.split(','), function (event) {
                return event + '.dialog-overlay';
            }).join(' ');
        }
    };
    // end _init


    // extend open function
    var _open = $.ui.dialog.prototype.open;
    $.ui.dialog.prototype.open = function () {
        var self = this;

        // apply original arguments
        _open.apply(this, arguments);

        // get dialog original size on open
        var oHeight = self.element.parent().outerHeight(),
            oWidth = self.element.parent().outerWidth(),
            isTouch = $("html").hasClass("touch");

        // responsive width & height
        var resize = function () {

            // check if responsive
            // dependent on modernizr for device detection / html.touch
            if (self.options.responsive === true || (self.options.responsive === "touch" && isTouch)) {
                var elem = self.element,
                    wHeight = $(window).height(),
                    wWidth = $(window).width(),
                    dHeight = elem.parent().outerHeight(),
                    dWidth = elem.parent().outerWidth(),
                    setHeight = Math.min(wHeight * self.options.scaleH, oHeight),
                    setWidth = Math.min(wWidth * self.options.scaleW, oWidth);

                // check & set height
                if ((oHeight + 100) > wHeight || elem.hasClass("resizedH")) {
                    elem.dialog("option", "height", setHeight).parent().css("max-height", setHeight);
                    elem.addClass("resizedH");
                }

                // check & set width
                if ((oWidth + 100) > wWidth || elem.hasClass("resizedW")) {
                    elem.dialog("option", "width", setWidth).parent().css("max-width", setWidth);
                    elem.addClass("resizedW");
                }

                // only recenter & add overflow if dialog has been resized
                if (elem.hasClass("resizedH") || elem.hasClass("resizedW")) {
                    elem.dialog("option", "position", "center");
                    elem.css("overflow", "auto");
                }
            }

            // add webkit scrolling to all dialogs for touch devices
            if (isTouch) {
                elem.css("-webkit-overflow-scrolling", "touch");
            }
        };

        // call resize()
        resize();

        // resize on window resize
        $(window).bind("resize", function () {
            resize();
        });

        // resize on orientation change
        if (window.addEventListener) {  // Add extra condition because IE8 doesn't support addEventListener (or orientationchange)
            window.addEventListener("orientationchange", function () {
                resize();
            });
        }

        // hide titlebar
        if (!self.options.showTitleBar) {
            self.uiDialogTitlebar.css({
                "height": 0,
                "padding": 0,
                "background": "none",
                "border": 0
            });
            self.uiDialogTitlebar.find(".ui-dialog-title").css("display", "none");
        }

        //hide close button
        if (!self.options.showCloseButton) {
            self.uiDialogTitlebar.find(".ui-dialog-titlebar-close").css("display", "none");
        }

        // close on clickOut
        if (self.options.clickOut && !self.options.modal) {
            // use transparent div - simplest approach (rework)
            $('<div id="dialog-overlay"></div>').insertBefore(self.element.parent());
            $('#dialog-overlay').css({
                "position": "fixed",
                "top": 0,
                "right": 0,
                "bottom": 0,
                "left": 0,
                "background-color": "transparent"
            });
            $('#dialog-overlay').click(function (e) {
                e.preventDefault();
                e.stopPropagation();
                self.close();
            });
            // else close on modal click
        } else if (self.options.clickOut && self.options.modal) {
            $('.ui-widget-overlay').click(function (e) {
                self.close();
            });
        }

        // add dialogClass to overlay
   //     if (self.options.dialogClass) {
     //       $('.ui-widget-overlay').addClass(self.options.dialogClass);
      //  }
    };
    //end open


    // extend close function
    var _close = $.ui.dialog.prototype.close;
    $.ui.dialog.prototype.close = function () {
        var self = this;
        // apply original arguments
        _close.apply(this, arguments);

        // remove dialogClass to overlay
        if (self.options.dialogClass) {
            $('.ui-widget-overlay').removeClass(self.options.dialogClass);
        }
        //remove clickOut overlay
        if ($("#dialog-overlay").length) {
            $("#dialog-overlay").remove();
        }
    };
    //end close
     <% } %>

function ctlCommentTerms_ClientValidate(sender, e)
{
    e.IsValid = jQuery("#<%=ctlCommentTerms.ClientID%>").is(':checked');
}
</script>
